"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.Logout = exports.Login = void 0;
var axios_1 = __importDefault(require("axios"));
var open_1 = __importDefault(require("open"));
var prompts_1 = __importDefault(require("prompts"));
var middlewareUrl = 'https://twcl-middleware.herokuapp.com';
var oauthUrl = 'https://api.twitter.com/oauth';
var getOauthToken = function () { return __awaiter(void 0, void 0, void 0, function () {
    var request, _a, oauthToken, oauthTokenSecret, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(middlewareUrl + "/getOauthToken")];
            case 1:
                request = _b.sent();
                _a = request.data, oauthToken = _a.oauthToken, oauthTokenSecret = _a.oauthTokenSecret;
                return [2 /*return*/, { oauthToken: oauthToken, oauthTokenSecret: oauthTokenSecret }];
            case 2:
                err_1 = _b.sent();
                console.error('Twitter APIに問題があるようです・・・時間を空けてからもう一度試してみてください。');
                return [2 /*return*/, {
                        oauthToken: '',
                        oauthTokenSecret: ''
                    }];
            case 3: return [2 /*return*/];
        }
    });
}); };
var getAccessToken = function (oauthToken, oauthTokenSecret, oauthVerifier) { return __awaiter(void 0, void 0, void 0, function () {
    var request, _a, accessToken, accessTokenSecret, err_2;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(middlewareUrl + "/getAccessToken", {
                        oauth_token: oauthToken,
                        oauth_token_secret: oauthTokenSecret,
                        oauth_verifier: oauthVerifier
                    })];
            case 1:
                request = _b.sent();
                _a = request.data, accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret;
                return [2 /*return*/, { accessToken: accessToken, accessTokenSecret: accessTokenSecret }];
            case 2:
                err_2 = _b.sent();
                console.error(err_2);
                return [2 /*return*/, {
                        accessToken: '',
                        accessTokenSecret: ''
                    }];
            case 3: return [2 /*return*/];
        }
    });
}); };
var userInput = function () { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, _a, oauthVerifier, userName, err_3;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                onCancel = function () {
                    console.error('Error: 入力内容が確認できませんでした...もう一度最初から入力してください。');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'text',
                            name: 'oauthVerifier',
                            message: 'ブラウザに表示されたトークンを入力してください',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        },
                        {
                            type: 'text',
                            name: 'userName',
                            message: '表示名を入力してください',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        }
                    ], { onCancel: onCancel })];
            case 1:
                _a = _b.sent(), oauthVerifier = _a.oauthVerifier, userName = _a.userName;
                return [2 /*return*/, { oauthVerifier: oauthVerifier, userName: userName }];
            case 2:
                err_3 = _b.sent();
                return [2 /*return*/, { oauthVerifier: '', userName: '' }];
            case 3: return [2 /*return*/];
        }
    });
}); };
var setDb = function (db, accessToken, accessTokenSecret, userName) { return __awaiter(void 0, void 0, void 0, function () {
    var data;
    return __generator(this, function (_a) {
        data = {
            type: 'user',
            name: userName,
            accessToken: accessToken,
            accessTokenSecret: accessTokenSecret,
            selected: true
        };
        db.insert(data, function (err, docs) {
            console.log("\u3088\u3046\u3053\u305D\u3001" + userName + "!");
        });
        return [2 /*return*/];
    });
}); };
exports.Login = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, oauthToken, oauthTokenSecret, _b, oauthVerifier, userName, _c, accessToken, accessTokenSecret;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0: return [4 /*yield*/, getOauthToken()];
            case 1:
                _a = _d.sent(), oauthToken = _a.oauthToken, oauthTokenSecret = _a.oauthTokenSecret;
                if (!(oauthToken && oauthTokenSecret)) return [3 /*break*/, 3];
                return [4 /*yield*/, open_1["default"](oauthUrl + "/authenticate?oauth_token=" + oauthToken)];
            case 2:
                _d.sent();
                return [3 /*break*/, 4];
            case 3: return [2 /*return*/, false];
            case 4: return [4 /*yield*/, userInput()];
            case 5:
                _b = _d.sent(), oauthVerifier = _b.oauthVerifier, userName = _b.userName;
                if (!oauthVerifier || !userName) {
                    return [2 /*return*/, false];
                }
                return [4 /*yield*/, getAccessToken(oauthToken, oauthTokenSecret, oauthVerifier)];
            case 6:
                _c = _d.sent(), accessToken = _c.accessToken, accessTokenSecret = _c.accessTokenSecret;
                if (!(accessToken && accessTokenSecret)) return [3 /*break*/, 8];
                return [4 /*yield*/, setDb(db, accessToken, accessTokenSecret, userName)];
            case 7:
                _d.sent();
                return [3 /*break*/, 9];
            case 8: return [2 /*return*/, false];
            case 9: return [2 /*return*/, true];
        }
    });
}); };
exports.Logout = function () {
    console.log('logout');
    return true;
};
